function [wng, Eg] = main( Nx, Ny, dx, dy, epr, td, mir, Nd, dg,...
                     Nh, hor, Nv, vert, f, term, nhor)
global m
mi0  = 4*pi*1e-7;          % premeability of vacuum
ep0  = 8.85e-12;           % permitivity of vacuum
epc   = epr.*(1-j*td);     % complex permittivity

twNx = 2*Nx;
G    = twNx*Ny;            % number of triangular elements
dx   = dx*1e-3;
dy   = dy*1e-3;

ParEl = zeros(7,G);

for m=1:Ny			% PARameters of ELements matrix
  for n=1:Nx
    g = (m-1)*twNx + n;
    ParEl(1,g) = dx(n);             % horizontal size
    ParEl(2,g) = dy(m);             % vertical size
    ParEl(5,g) = 0.5*dx(n)*dy(m);   % area of the element
    ParEl(6,g) = dx(n)/dy(m);       % cotg 1
    ParEl(7,g) = dy(m)/dx(n);       % cotg 3
    g = g + Nx;
    ParEl(1,g) = dx(n);
    ParEl(2,g) = dy(m);
    ParEl(5,g) = 0.5*dx(n)*dy(m);
    ParEl(6,g) = dx(n)/dy(m);
    ParEl(7,g) = dy(m)/dx(n);
  end
end

if term==0
  for m=1:Ny			% PARameters of ELements matrix
    for n=1:Nx
      g = (m-1)*twNx + n;
      ParEl(3,g) = epc(m);		% complex rel.permitivity
      ParEl(4,g) = mir(m);		% relative permeability
      g = g + Nx;
      ParEl(3,g) = epc(m);
      ParEl(4,g) = mir(m);		% relative permeability
    end
  end
else
  for m=1:Ny			% PARameters of ELements matrix
    for n=1:Nx
      g = (m-1)*twNx + n;
      ParEl(3,g) = mir(m);		% relative permeability
      ParEl(4,g) = epc(m);		% complex rel.permitivity
      g = g + Nx;
      ParEl(3,g) = mir(m);		% relative permeability
      ParEl(4,g) = epc(m);
    end
  end
end  
             % boundary conditions
[nze,nzn,bnd] = mk_bnd( Nx, Ny, Nh, hor, Nv, vert, Nd, dg, term);
[Ce,Ee,Cn,En,nze,nzn] = mk_c( Nx, Ny, bnd, nze, nzn, nhor);

             % building global matr.

omg  = 2*pi*f*1e+9;                % angular frequency
k0   = omg*omg*mi0*ep0;            % square of wavenumber in vacuum

             % boundary conditions
             
[K,L] = glob( Ce, Ee, nze, Cn, En, nzn, ParEl, Nx, Ny, k0);

             % solution of the matrix problem

[E,G] = eig( full( K), full(L));   % eigenvalue problem
wn    = diag( sqrt( G));           % wavenumbers

n_wn = size( G, 1);
m = 1;
for n=1:n_wn
  if (real(wn(n))<1e+1) & (imag(wn(n))>1e-1)
    wng( m) = wn(n);
    Eg(:,m) = E(:,n);
    m = m + 1;
  end
end
% m
% m = POCET VYPOCTENYCH VIDU