function [nze,nzn,bnd] = mk_bnd( Nx, Ny, Nh, horiz, Nv, vert, Nd, diag, term)

% creates boundary vector
% - its elements corresponds to global edges/nodes
% - if boundary condition requires zero edge/nod value bdn = 0
% - otherwise bnd = 1

% g = total number of global edges/nodes

iNx = Nx + 1;
iNy = Ny + 1;
dNx = Nx - 1;
dNy = Ny - 1;

G   = (Nx + iNx)*(Ny + iNy);
bnd = ones(1,G);
nzn = iNx*iNy;
nze = G - nzn;

hlp = 0 + 1;		% diagonal edges
g   = 0 + Nx*Ny;

if Nd~=0
  for m=1:Nd		% eliminat. zero diag.e.
    xx = Nx*(diag(3,m)-1) - 1;
    dn = xx + diag(1,m);
    up = xx + diag(2,m);
    for n=dn:up
      bnd(hlp+n) = 0;
      nze = nze - 1;
    end
  end
end

hlp = g + 1;		% horizontal edges
g   = g + Nx*iNy;

if Nh~=0
  for m=1:Nh		% eliminat. zero horiz.e.
    xx = Nx*horiz(3,m);
    dn = xx + horiz(1,m);
    up = xx + horiz(2,m);
    for n=dn:up
      bnd(hlp+n-1) = 0;
      nze = nze - 1;
    end
  end
end

hlp = g + 1;		% vertical edges
g   = g + iNx*Ny;

if Nv~=0
  for m=1:Nv		% eliminat. zero vert.e.
    xx = (vert(1,m)-1)*iNx + vert(3,m);
    up = vert(2,m) - vert(1,m);
    for n=0:up
      bnd(hlp+xx+n*iNx) = 0;
      nze = nze - 1;
    end
  end 
end

hlp = g + 1;		% nodes
g   = g + iNx*iNy;

if Nh~=0
  for m=1:Nh		% eliminat. zero nodes
    xx = iNx*horiz(3,m);
    dn = xx + horiz(1,m);
    up = xx + horiz(2,m) + 1;
    for n=dn:up
      bnd(hlp+n-1) = 0;
      nzn = nzn - 1;
    end
  end
end

if Nv~=0
  for m=1:Nv
    xx = (vert(1,m)-1)*iNx + vert(3,m);
    up = vert(2,m) - vert(1,m) + 1;
    for n=0:up
      if bnd(hlp+xx+n*iNx)~=0
        bnd(hlp+xx+n*iNx) = 0;
        nzn = nzn - 1;
      end;
    end
  end
end

% if term==0
%  nzn = nzn + 2*Nv;	
%end